/****************************************
*  Computer Algebra System SINGULAR     *
****************************************/
/* $Id: mmalloc.c,v 1.5 1998/01/24 17:22:06 Singular Exp $ */

/*
* ABSTRACT:
*/

#define _POSIX_SOURCE 1

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "omalloc.h"
#include "mmprivat.h"

size_t mmSizeL( void* adr )
{
  if (adr!=NULL)
  {
    adr = (size_t*)adr-1;
    return *(size_t*)adr;
  }
  return 0;
}

void * mmAlloc( size_t size )
{
  size_t thesize = size + sizeof( void * );
  size_t * dummy = (size_t*)mmAllocBlock( thesize );
  *dummy = thesize;
  return (void*)(dummy+1);
}

void * mmAlloc0( size_t size )
{
  size_t thesize = size + sizeof( void * );
  size_t * dummy = (size_t*)mmAllocBlock0( thesize );
  *dummy = thesize;
  return (void*)(dummy+1);
}

void mmFree( void* adr )
{
  if (adr!=NULL)
  {
    adr = (size_t*)adr-1;
    mmFreeBlock( adr, *(size_t*)adr );
  }
}


void mmFreeSize(void* adr, size_t s)
{
  if (adr!=NULL)
  {
    adr = (size_t*)adr-1;
    mmFreeBlock( adr, *(size_t*)adr );
  }
}

void * mmRealloc( void* adr, size_t newsize )
{
  if (adr!=NULL)
  {
    size_t *aadr=(size_t*)(adr)-1;
    size_t oldsize = *aadr;
    size_t tsize=oldsize-sizeof(void *);
    void* newadr;
    if (newsize!=0) newadr= mmAlloc( newsize );
    else newadr=NULL;
    if (newsize!=0)
    {
      if (tsize > newsize) tsize=newsize;
      memcpy( newadr, adr, tsize );
    }  
    mmFreeBlock( aadr,oldsize );
    return newadr;
  }
  if (newsize!=0)
    return mmAlloc(newsize);
  return NULL;
}

void * mmRealloc0( void* adr, size_t newsize )
{
  size_t *aadr=(size_t*)(adr)-1;
  size_t oldsize = *aadr;
  void* newadr = mmAlloc0( newsize );
  size_t tsize=oldsize-sizeof(void *);
  if (tsize > newsize) tsize=newsize;
  memcpy( newadr, adr, tsize );
  mmFreeBlock( aadr,oldsize );
  return newadr;
}

void * mmReallocSize( void* adr, size_t olds, size_t newsize )
{
  size_t *aadr=(size_t*)(adr)-1;
  size_t oldsize = *aadr;
  void* newadr = mmAlloc( newsize );
  size_t tsize=oldsize-sizeof(void *);
  if (tsize > newsize) tsize=newsize;
  memcpy( newadr, adr, tsize );
  mmFreeBlock( aadr,oldsize );
  return newadr;
}

void memcpyW(void* p1, void* p2, long l)
{
  long _i = l;                                  
  long* _s1 = (long*) p1;                       
  const long* _s2 = (long*) p2;                 
                                                
  for (;;)                                      
  {                                             
    *_s1 = *_s2;                                
    _i--;                                       
    if (_i == 0) break;                         
    _s1++;                                      
    _s2++;                                      
  }                                             
}                                               

