/****************************************
*  Computer Algebra System SINGULAR     *
****************************************/
/* $Id: mmallocs.c,v 1.5 1998/04/01 16:50:18 Singular Exp $ */

/*
* ABSTRACT:
*/

#define _POSIX_SOURCE 1
#define MAXPATHLEN 1024

#include <stdlib.h>
#include <stdio.h>
#include "omalloc.h"
#include "mmprivat.h"

void * mmAllocSpecialized( void )
{
  mcb result;

  if ( mm_theList[mm_specIndex] == NULL )
  {
     /* result = mmGetMemory(mm_specSize); */
     int r = MAXDATA-mm_specSize;
     char *adr = (char *)mmGetBlock();
     result = (mcb)adr;
     while(r>=mm_specSize)
     {
       adr+=mm_specSize;
       *((mcb)adr) = mm_theList[mm_specIndex];
       mm_theList[mm_specIndex] = (mcb)adr;
       r-=mm_specSize;
     }
  }
  else
  {
    result = mm_theList[mm_specIndex];
    mm_theList[mm_specIndex] = (mcb)*result;
  }  
  return (void*)result;
}

void mmFreeSpecialized( void* adr )
{
  *((mcb)adr) = mm_theList[mm_specIndex];
  mm_theList[mm_specIndex] = (mcb)adr;
}

void mmSpecializeBlock( size_t size )
{
  if (mm_specIndex != mmGetIndex( size ))
  {
    mm_specIndex = mmGetIndex( size );
    if (mm_specIndex<0)
    {
      printf("too many ring variables...\n");
    }
    else
    {
      mm_specSize = mmGetSize(mm_specIndex);
    }
  }
}

omBin omGetSpecBin(size_t S)
{
  omBin r=Alloc(sizeof(omBin));
  r->s=S;
  return r;
}  

void omMergeStickyBinIntoBin(omBin sticky_bin, omBin into_bin)
{
  Free(sticky_bin,sizeof(omBin));
}

void omUnGetSpecBin(omBin *bin)
{
  Free(*bin,sizeof(omBin));
  *bin=NULL;
}

void * omMemDup(void *p)
{
  void *r;
  if (p==NULL) return NULL;
  p=(size_t*)p -1;
  r=mmAllocBlock(*(size_t*)p);
  memcpy(r,p,*(size_t*)p);
  r=(size_t*)r+1;
  return r;
}  

char * omFindExec (const char *name, char* executable)
{
  strcpy(executable, name);
  return executable;
}  
static char om_this_prog[MAXPATHLEN] = "";

void omInitRet_2_Info(const char* argv0)
{
  char buf[MAXPATHLEN];

  if (argv0 != NULL && omFindExec(argv0, buf))
  {
    strcpy(om_this_prog, buf);
  }
}

