#ifndef MEMPRIVAT_H
#define MEMPRIVAT_H
/****************************************
*  Computer Algebra System SINGULAR     *
****************************************/
/* $Id: mmprivat.h,v 1.13 1998/06/13 14:11:50 Singular Exp $ */
/*
* ABSTRACT
*/

#define MAXLIST_8 18
#define MAXLIST_4 21

#ifdef ALIGN_8
  #define MAXLIST MAXLIST_8
  #ifdef HAVE_GC
    #define MAXDATA 4088   /* 4k - sizeof(ptr) */
  #else
    #define MAXDATA 4096   /* 4k */
  #endif
#else
  #define MAXLIST MAXLIST_4
  #ifdef HAVE_GC
    #define MAXDATA 4092   /* 4k - sizeof(ptr) */
  #else
    #define MAXDATA 4096   /* 4k */
  #endif
#endif

typedef void ** mcb;

extern const size_t mm_mcbSizes [];

typedef enum { MM_NORMAL, MM_TMP, MM_SWITCHED } status_t;

extern mcb *mm_theList;
extern mcb mm_tmpList[];
extern mcb mm_normList[];

extern status_t mm_status;

extern int mm_bytesUsed;
extern int mm_bytesReal;
extern int mm_bytesTmp;
extern int mm_bytesNorm;
#ifdef HAVE_SBRK
extern unsigned long mm_SbrkInit;
#endif

extern int mm_specIndex;

extern int mm_printMark;

#define mmGetSpecIndex() mm_specIndex

#define MM_TMPFLAG  1
#define MM_NORMFLAG 2
#define MM_FREEFLAG 4
#define MM_USEDFLAG 8

#define PATTERN -2
#define PATTERN2 'A'
#define PATTERN3 'Z'

/* stuff to handle index and sizes of free lists */
#define MAX_BLOCK_SIZE  1024
#define MAX_INDEX ((MAX_BLOCK_SIZE - 1) >> 2)

#define HAVE_INDEX_TABLE
#ifdef  HAVE_INDEX_TABLE

#define INDEX_ENTRY_T   char

extern const INDEX_ENTRY_T mm_IndexTable[];

/* Hmm , size get's evaluated twice -- should not be a problem, though */
#ifndef GENERATE_INDEX_TABLE
#define mmGetIndex(size)                                        \
 (size <= MAX_BLOCK_SIZE ? mm_IndexTable[(size -1) >> 2] : -1)
#endif

#else

/* #define MAX_INDEX MAXLIST*/
int mmGetIndex( size_t );
#endif

#define mmGetSize( index ) mm_mcbSizes[index]

#define DebugOffsetFront 0

#define DebugOffsetBack 0

#define SizeFromRealSize( size ) (size - DebugOffsetFront - DebugOffsetBack)
#define RealSizeFromSize( size ) (size + DebugOffsetFront + DebugOffsetBack)

mcb mmNewMCBList( int i );

/* stuff for heap handling */

void * mmGetMemory( size_t size );


/* stuff for block handling */

void * mmGetBlock( void );


/* since free functions get a (void*) that is in real life a (void**) */

#define r(adr) (*(void**)adr)

#endif /* MEMPRIVATE_H */

